{
===============================================================================
  Copyright (©) 2007. Rodax Software.
===============================================================================
  Los contenidos de este fichero son propiedad de Rodax Software titular del
  copyright. Este fichero sólo podrá ser copiado, distribuido y utilizado,
  en su totalidad o en parte, con el permiso escrito de Rodax Software, o de
  acuerdo con los términos y condiciones establecidas en el acuerdo/contrato
  bajo el que se suministra.
  -----------------------------------------------------------------------------
  Web:  www.rodax-software.com
===============================================================================
  Fecha primera versión: 
  Versión actual: 1.0.0
  Fecha versión actual: 
===============================================================================
  Modificaciones:

    Fecha         Comentarios
    ---------------------------------------------------------------------------
===============================================================================
}

unit uDataModuleTiposIVA;

interface

uses
  SysUtils, Classes, DB, uDADataTable, uDABINAdapter,
  uDAScriptingProvider, uDACDSDataTable, uROWinInetHttpChannel, uROTypes,
  uRORemoteService, uROClient, uROBinMessage,
  uDADesigntimeCall,

  uIDataModuleTiposIVA, uBizTiposIVA, uDADataStreamer, uDARemoteDataAdapter,
  uDAInterfaces, uRODynamicRequest, uDABin2DataStreamer, uDAMemDataTable,
  uDataModuleBase;

type
  TDataModuleTiposIVA = class(TDataModuleBase, IDataModuleTiposIVA)
    RORemoteService: TRORemoteService;
    rda_TiposIVA: TDARemoteDataAdapter;
    Bin2DataStreamer: TDABin2DataStreamer;
    tbl_TiposIVA: TDAMemDataTable;
    ds_TiposIVA: TDADataSource;
    procedure DAClientDataModuleCreate(Sender: TObject);
  public
    function GetItems: IBizTipoIVA;
    function GetItem(const ID : Integer) : IBizTipoIVA;
    function NewItem : IBizTipoIVA;
  end;

implementation

{$R *.DFM}

uses
  FactuGES_Intf, uDataModuleConexion, uDataTableUtils, cxControls, 
  schTiposIVAClient_Intf;

{ TDataModuleTiposIVA }

procedure TDataModuleTiposIVA.DAClientDataModuleCreate(Sender: TObject);
begin
  RORemoteService.Channel := dmConexion.Channel;
  RORemoteService.Message := dmConexion.Message;
end;

function TDataModuleTiposIVA.GetItems: IBizTipoIVA;
var
  ATipoIVA : TDAMemDataTable;
begin
  ShowHourglassCursor;
  try
    ATipoIVA := CloneDataTable(tbl_TiposIVA);
    ATipoIVA.BusinessRulesID := BIZ_CLIENT_TipoIVA;

    Result := (ATipoIVA as IBizTipoIVA);
  finally
    HideHourglassCursor;
  end;
end;

function TDataModuleTiposIVA.NewItem: IBizTipoIVA;
begin
  Result := GetItem(ID_NULO)
end;

function TDataModuleTiposIVA.GetItem(const ID: Integer): IBizTipoIVA;
var
  Condicion: TDAWhereExpression;
begin
  ShowHourglassCursor;
  try
    Result := Self.GetItems;

    with Result.DataTable.DynamicWhere do
    begin
      // (ID = :ID)
      Condicion := NewBinaryExpression(NewField('', fld_TiposIVAID), NewConstant(ID, datInteger), dboEqual);

      if IsEmpty then
         Expression := Condicion
      else
         Expression := NewBinaryExpression(Expression, Condicion, dboAnd);
    end;

  finally
    HideHourglassCursor;
  end;
end;

end.
